#ifndef MI_SPARSE_VECTOR_H__
#define MI_SPARSE_VECTOR_H__

#include <fstream>
#include <vector>
#include "vector.h"
#include <string>

using namespace std;

// Multiple Instance Sparse Vectors
class MISparseVector: public lasvm_sparsevector_t {
public:
  int label_;
  vector<int> labels;
  vector<int> acquired;
  vector<int> indices;
  vector<double> probs;
  int size_;
  int bag_id;
  double acost;
  double pcost;
  char imgname[20];
  vector<lasvm_sparsevector_t*> instances_;
  
public:
  MISparseVector();
  virtual ~MISparseVector();
  
  lasvm_sparsevector_t* getInstance(int i);
  void getRepresentation(double * out);
  lasvm_sparsevector_t *getRepresentation();
  void printX(int dim);
  void addInstance(lasvm_sparsevector_t* instance);
  void deleteInstance(int pos);
  void deletePointer(lasvm_sparsevector_t* instance);
  int size() const;
  virtual double norm() const;
  double dot_product(MISparseVector *misv) const;
  double rbf_dot_product(MISparseVector *misv,double) const;
  virtual void write(ofstream &stream_out);
};


#endif
